#include "neo.h"
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <string.h>

/*
 *  The only reason this is necessary is because of a bug in the
 *  2900's and 4000's.
 *
 *  Cisco sucks.
 */

int neo_command_locate_simple_cat2948(neo_device *d, neo_searchable *s, neo_locationlist *ans) {
  neo_snmpresponselist *rl;
  neo_macaddr *m;
  char macints[300];
  int ret, i, j;
  neo_boardport bp;
  neo_location *loc;

  m=neo_searchable_get_macaddr(s);
  neo_macaddr_to_dotted_ints_string(m, macints);

  if (neo_global_is_debug(g)) printf("command_locate_simple_cat2948: dumping bridge cam table for %s\n", neo_device_get_name(d));
  rl=neo_snmp_many_requests_by_variable(neo_device_get_name(d), ".1.3.6.1.2.1.17.4.3.1.2");

  if (rl==NULL) {
    if (neo_error==NEO_ERR_TIMEOUT || neo_error==NEO_ERR_CONTACT) {
      printf("Could not contact device %s\n", neo_device_get_name(d));
      neo_snmpresponselist_free_all(rl);
      return(-1);
    } else {
      return(0);
    }
  }

  /* see if any match as the source mac addr */
  j=neo_snmpresponselist_get_size(rl);
  for (i=0; i<j; i++) {
    char *ptr1, *ptr2;
    char *var, *val;

    var=neo_snmpresponselist_get_var(rl, i);
    ptr1=var+23;
    ptr2=strchr(ptr1,'.')+1;
    if (!strncmp(macints, ptr2, strlen(macints))) {
      val=neo_snmpresponselist_get_val(rl, i);

      if (neo_global_is_debug(g)) printf("command_locate_simple_cat2948: have bridgeindex %i\n", atoi(val));

      ret=neo_function_standardbridge_get_ifnum_from_port(d, atoi(val));
      if (neo_global_is_debug(g)) printf("command_locate_simple_cat2948: have ifindex %i\n", ret);
      if (ret<0) continue;

      loc=malloc(sizeof(neo_location));
      neo_device_set_boardport_from_ifindex(d, &bp, ret);
      neo_location_create_from_boardport_and_device(loc, &bp, neo_device_get_name(d));
      neo_locationlist_append_element(ans, loc);
      return(0);
    }
  }
  return(0);
}
